(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("react-dom"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "react-dom"], factory);
	else if(typeof exports === 'object')
		exports["ReactContainerQuery"] = factory(require("react"), require("react-dom"));
	else
		root["ReactContainerQuery"] = factory(root["React"], root["ReactDOM"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_6__, __WEBPACK_EXTERNAL_MODULE_7__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	exports.__esModule = true;
	
	var _createContainerQueryMixin = __webpack_require__(2);
	
	Object.defineProperty(exports, 'createContainerQueryMixin', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_createContainerQueryMixin).default;
	  }
	});
	
	var _applyContainerQuery = __webpack_require__(3);
	
	Object.defineProperty(exports, 'applyContainerQuery', {
	  enumerable: true,
	  get: function get() {
	    return _interopRequireDefault(_applyContainerQuery).default;
	  }
	});

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ },
/* 1 */
/***/ function(module, exports) {

	"use strict";
	
	exports.__esModule = true;
	exports.toPairs = toPairs;
	exports.shallowCopyObj = shallowCopyObj;
	/**
	 * Convert obj to array of key value pairs
	 *
	 * @param {Object} obj A plain JS object
	 *
	 * @return {Array<Pair<string, Object>>} Pairs
	 */
	function toPairs(obj) {
	  return Object.keys(obj).map(function (key) {
	    return [key, obj[key]];
	  });
	}
	
	/**
	 * Create a shallow copy of provided object, will only use Object.keys
	 * returned key.
	 *
	 * @param {Object|null} obj Object to copy
	 *
	 * @return {Object|null} A shallow copy of provided object, is input null,
	 *                       return null.
	 */
	function shallowCopyObj(obj) {
	  if (obj === null) {
	    return null;
	  }
	
	  var copy = {};
	  for (var _iterator = Object.keys(obj), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
	    var _ref;
	
	    if (_isArray) {
	      if (_i >= _iterator.length) break;
	      _ref = _iterator[_i++];
	    } else {
	      _i = _iterator.next();
	      if (_i.done) break;
	      _ref = _i.value;
	    }
	
	    var key = _ref;
	
	    copy[key] = obj[key];
	  }
	  return copy;
	}

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	exports.__esModule = true;
	exports.default = createContainerQueryMixin;
	
	var _raf = __webpack_require__(5);
	
	var _containerQuery = __webpack_require__(4);
	
	var _DataStructure = __webpack_require__(1);
	
	/**
	 * Create a mixin that can be
	 *
	 * @param {Object} query - Container query definitions
	 * @param {Object} [opts] - Options
	 * @param {boolean} [opts.setAttribute] - When true, mixin will set or unset
	 *                                        attributes on container element
	 *                                        according to current active container
	 *                                        query
	 *
	 * @return {Object} A mixin object that can be applied to a component
	 */
	function createContainerQueryMixin(query) {
	  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
	
	  var _ref$setAttribute = _ref.setAttribute;
	  var setAttribute = _ref$setAttribute === undefined ? false : _ref$setAttribute;
	
	
	  var getClasses = (0, _containerQuery.parseQuery)(query);
	
	  return {
	    defineContainer: function defineContainer(component) {
	      this._containerElement = component;
	    },
	    componentDidMount: function componentDidMount() {
	      var _this = this;
	
	      this._containerQuerySelectorMap = null;
	      this._size = { width: null, height: null };
	      this._rafId = null;
	
	      var checkDimension = function checkDimension() {
	        var _containerElement = _this._containerElement;
	        var width = _containerElement.clientWidth;
	        var height = _containerElement.clientHeight;
	
	
	        var changed = false;
	
	        if (_this._size.width !== width) {
	          changed = true;
	        }
	
	        if (_this._size.height !== height) {
	          changed = true;
	        }
	
	        _this._size.width = width;
	        _this._size.height = height;
	
	        if (changed) {
	          _this._updateAttributes();
	        }
	
	        _this._rafId = (0, _raf.requestAnimationFrame)(checkDimension);
	      };
	
	      checkDimension();
	    },
	    componentWillUnmount: function componentWillUnmount() {
	      (0, _raf.cancelAnimationFrame)(this._rafId);
	      this._rafId = null;
	      this._containerElement = null;
	
	      if (this.containerQueryWillUpdate) {
	        this.containerQueryWillUpdate((0, _DataStructure.shallowCopyObj)(this._containerQuerySelectorMap));
	      }
	
	      this._containerQuerySelectorMap = null;
	
	      if (this.containerQueryDidUpdate) {
	        this.containerQueryDidUpdate((0, _DataStructure.shallowCopyObj)(this._containerQuerySelectorMap));
	      }
	    },
	    _updateAttributes: function _updateAttributes() {
	      var selectorMap = getClasses(this._size);
	
	      if ((0, _containerQuery.isSelectorMapEqual)(this._containerQuerySelectorMap, selectorMap)) {
	        return;
	      }
	
	      if (this.containerQueryWillUpdate) {
	        this.containerQueryWillUpdate((0, _DataStructure.shallowCopyObj)(this._containerQuerySelectorMap));
	      }
	
	      this._containerQuerySelectorMap = selectorMap;
	
	      if (setAttribute) {
	        for (var _iterator = (0, _DataStructure.toPairs)(this._containerQuerySelectorMap), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
	          var _ref2;
	
	          if (_isArray) {
	            if (_i >= _iterator.length) break;
	            _ref2 = _iterator[_i++];
	          } else {
	            _i = _iterator.next();
	            if (_i.done) break;
	            _ref2 = _i.value;
	          }
	
	          var _ref3 = _ref2;
	          var selectorName = _ref3[0];
	          var isOn = _ref3[1];
	
	          if (isOn) {
	            this._containerElement.setAttribute(selectorName, '');
	          } else {
	            this._containerElement.removeAttribute(selectorName);
	          }
	        }
	      }
	
	      if (this.containerQueryDidUpdate) {
	        this.containerQueryDidUpdate((0, _DataStructure.shallowCopyObj)(this._containerQuerySelectorMap));
	      }
	    }
	  };
	}

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	exports.__esModule = true;
	exports.default = applyContainerQuery;
	
	var _react = __webpack_require__(6);
	
	var _reactDom = __webpack_require__(7);
	
	var _createContainerQueryMixin = __webpack_require__(2);
	
	var _createContainerQueryMixin2 = _interopRequireDefault(_createContainerQueryMixin);
	
	var _DataStructure = __webpack_require__(1);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	/**
	 * Apply container query using higher order component style
	 *
	 * Refer to:
	 * https://gist.github.com/sebmarkbage/ef0bf1f338a7182b6775
	 *
	 * @param {Component} Container - A react component
	 * @param {Object} query - Container query definitions
	 * @param {Object} [opts] - Additional options passed to `createContainerQueryMixin`
	 * @param {string} [opts.propName='containerQuery'] - the property name to pass to applied container component
	 *
	 * @return {Component} A container query element
	 */
	function applyContainerQuery(Container, query) {
	  var _ref = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
	
	  var _ref$propName = _ref.propName;
	  var propName = _ref$propName === undefined ? 'containerQuery' : _ref$propName;
	  var setAttribute = _ref.setAttribute;
	
	
	  return (0, _react.createClass)({
	    propTypes: Container.propTypes,
	    displayName: 'ContainerQuery',
	    mixins: [(0, _createContainerQueryMixin2.default)(query, { setAttribute: setAttribute })],
	
	    getInitialState: function getInitialState() {
	      return { stateMap: null };
	    },
	    defineContainerComponent: function defineContainerComponent(ref) {
	      this.defineContainer((0, _reactDom.findDOMNode)(ref));
	    },
	    containerQueryDidUpdate: function containerQueryDidUpdate(stateMap) {
	      this.setState({ stateMap: stateMap });
	    },
	    render: function render() {
	      var props = (0, _DataStructure.shallowCopyObj)(this.props);
	
	      props.ref = this.defineContainerComponent;
	      props[propName] = this.state.stateMap;
	
	      return (0, _react.createElement)(Container, props);
	    }
	  });
	}

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	exports.__esModule = true;
	exports.isSelectorMapEqual = isSelectorMapEqual;
	exports.parseQuery = parseQuery;
	
	var _DataStructure = __webpack_require__(1);
	
	/**
	 * Test if two classMap object are the same
	 *
	 * @param {Object|null} a A plain JS object, with string as key, boolean as value
	 * @param {Object|null} b Same as a
	 *
	 * @return {boolean} True if a and b have the same key and mapped value,
	 *                   or both are null.
	 */
	function isSelectorMapEqual(a, b) {
	  if (a === b) {
	    return true;
	  } else if (a === null || b === null) {
	    return false;
	  }
	
	  var aKeys = Object.keys(a);
	  var bKeys = Object.keys(b);
	
	  if (aKeys.length !== bKeys.length) {
	    return false;
	  }
	
	  for (var _iterator = aKeys, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
	    var _ref;
	
	    if (_isArray) {
	      if (_i >= _iterator.length) break;
	      _ref = _iterator[_i++];
	    } else {
	      _i = _iterator.next();
	      if (_i.done) break;
	      _ref = _i.value;
	    }
	
	    var key = _ref;
	
	    if (a[key] !== b[key]) {
	      return false;
	    }
	  }
	
	  return true;
	}
	
	/**
	 * A curried function. Take query defination and size object,
	 * return a selectorMap by testing size against rules in query defination
	 *
	 * @param {Object} query Object contains container query break points
	 * @param {Object} size  With width and height property
	 *
	 * @return {Object} A map of selector to boolean
	 */
	function parseQuery(query) {
	  var rules = [];
	
	  for (var _iterator2 = (0, _DataStructure.toPairs)(query), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
	    var _ref2;
	
	    if (_isArray2) {
	      if (_i2 >= _iterator2.length) break;
	      _ref2 = _iterator2[_i2++];
	    } else {
	      _i2 = _iterator2.next();
	      if (_i2.done) break;
	      _ref2 = _i2.value;
	    }
	
	    var _ref6 = _ref2;
	    var selectorName = _ref6[0];
	    var _ref6$ = _ref6[1];
	    var minWidth = _ref6$.minWidth;
	    var maxWidth = _ref6$.maxWidth;
	    var minHeight = _ref6$.minHeight;
	    var maxHeight = _ref6$.maxHeight;
	
	    rules.push([selectorName, {
	      minWidth: minWidth || 0,
	      maxWidth: maxWidth || Infinity,
	      minHeight: minHeight || 0,
	      maxHeight: maxHeight || Infinity
	    }]);
	  }
	
	  return function (_ref3) {
	    var width = _ref3.width;
	    var height = _ref3.height;
	
	    var selectorMap = {};
	
	    for (var _iterator3 = rules, _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
	      var _ref4;
	
	      if (_isArray3) {
	        if (_i3 >= _iterator3.length) break;
	        _ref4 = _iterator3[_i3++];
	      } else {
	        _i3 = _iterator3.next();
	        if (_i3.done) break;
	        _ref4 = _i3.value;
	      }
	
	      var _ref5 = _ref4;
	      var selectorName = _ref5[0];
	      var _ref5$ = _ref5[1];
	      var minWidth = _ref5$.minWidth;
	      var maxWidth = _ref5$.maxWidth;
	      var minHeight = _ref5$.minHeight;
	      var maxHeight = _ref5$.maxHeight;
	
	      selectorMap[selectorName] = minWidth <= width && width <= maxWidth && minHeight <= height && height <= maxHeight;
	    }
	
	    return selectorMap;
	  };
	}

/***/ },
/* 5 */
/***/ function(module, exports) {

	'use strict';
	
	exports.__esModule = true;
	var requestAnimationFrame = void 0;
	var cancelAnimationFrame = void 0;
	
	if (typeof document === 'undefined') {
	  // For Node.js
	  exports.requestAnimationFrame = requestAnimationFrame = function requestAnimationFrame() {};
	  exports.cancelAnimationFrame = cancelAnimationFrame = function cancelAnimationFrame() {};
	} else {
	  (function () {
	    var vendors = ['ms', 'moz', 'webkit', 'o'];
	    var lastTime = 0;
	
	    exports.requestAnimationFrame = requestAnimationFrame = window.requestAnimationFrame;
	    exports.cancelAnimationFrame = cancelAnimationFrame = window.cancelAnimationFrame;
	
	    for (var x = 0; x < vendors.length && !requestAnimationFrame; x++) {
	      exports.requestAnimationFrame = requestAnimationFrame = window[vendors[x] + 'RequestAnimationFrame'];
	      exports.cancelAnimationFrame = cancelAnimationFrame = window[vendors[x] + 'CancelAnimationFrame'] || window[vendors[x] + 'CancelRequestAnimationFrame'];
	    }
	
	    if (!requestAnimationFrame) {
	      exports.requestAnimationFrame = requestAnimationFrame = function requestAnimationFrame(callback) {
	        var currTime = new Date().getTime();
	        var timeToCall = Math.max(0, 16 - (currTime - lastTime));
	        var id = window.setTimeout(function () {
	          callback(currTime + timeToCall);
	        }, timeToCall);
	        lastTime = currTime + timeToCall;
	        return id;
	      };
	    }
	
	    if (!cancelAnimationFrame) {
	      exports.cancelAnimationFrame = cancelAnimationFrame = function cancelAnimationFrame(id) {
	        return clearTimeout(id);
	      };
	    }
	  })();
	}
	
	exports.requestAnimationFrame = requestAnimationFrame;
	exports.cancelAnimationFrame = cancelAnimationFrame;

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_6__;

/***/ },
/* 7 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=react-container-query.js.map